zenilib: TiXmlDocument Class Reference

zenilib 0.5.3.0

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Friends Macros Groups Pages
Public Member Functions | Protected Member Functions | List of all members
TiXmlDocument Class Reference

`#include <tinyxml.h>`

Inherits TiXmlNode.

## Public Member Functions

| TiXmlDocument ()
| Create an empty document, that has no name. More...
| TiXmlDocument (const char *documentName)
| Create a document with a name. The name of the document is also the filename of the xml. More...
| TiXmlDocument (const TiXmlDocument &copy)
virtual | ~TiXmlDocument ()
virtual bool | Accept (TiXmlVisitor *content) const
void | ClearError ()
bool | Error () const
int | ErrorCol () const
| The column where the error occured. See ErrorRow() More...
const char * | ErrorDesc () const
| Contains a textual (english) description of the error if one occurs. More...
int | ErrorId () const
int | ErrorRow () const
bool | LoadFile (TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
bool | LoadFile (const char *filename, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
| Load a file using the given filename. Returns true if successful. More...
bool | LoadFile (FILE *, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
void | operator= (const TiXmlDocument &copy)
virtual const char * | Parse (const char *p, TiXmlParsingData *data=0, TiXmlEncoding encoding=TIXML_DEFAULT_ENCODING)
void | Print () const
virtual void | Print (FILE *cfile, int depth=0) const
| Print this Document to a FILE stream. More...
const TiXmlElement * | RootElement () const
TiXmlElement * | RootElement ()
bool | SaveFile () const
| Save a file using the current document value. Returns true if successful. More...
bool | SaveFile (const char *filename) const
| Save a file using the given filename. Returns true if successful. More...
bool | SaveFile (FILE *) const
| Save a file using the given FILE*. Returns true if successful. More...
void | SetError (int err, const char *errorLocation, TiXmlParsingData *prevData, TiXmlEncoding encoding)
void | SetTabSize (int _tabsize)
int | TabSize () const
virtual const TiXmlDocument * | ToDocument () const
| Cast to a more defined type. Will return null not of the requested type. More...
virtual TiXmlDocument * | ToDocument ()
| Cast to a more defined type. Will return null not of the requested type. More...
Public Member Functions inherited from TiXmlNode
virtual | ~TiXmlNode ()
void | Clear ()
| Delete all the children of this node. Does not affect 'this'. More...
const TiXmlNode * | FirstChild () const
| The first child of this node. Will be null if there are no children. More...
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild (const char *value) const
TiXmlNode * | FirstChild (const char *_value)
| The first child of this node with the matching 'value'. Will be null if none found. More...
const TiXmlElement * | FirstChildElement () const
| Convenience function to get through elements. More...
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement (const char *_value) const
| Convenience function to get through elements. More...
TiXmlElement * | FirstChildElement (const char *_value)
const TiXmlDocument * | GetDocument () const
TiXmlDocument * | GetDocument ()
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
| This flavor of IterateChildren searches for children with a particular 'value'. More...
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild ()
| The last child of this node. Will be null if there are no children. More...
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LastChild (const char *_value)
| The last child of this node matching 'value'. Will be null if there are no children. More...
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
const TiXmlNode * | NextSibling () const
| Navigate to a sibling node. More...
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling (const char *) const
| Navigate to a sibling node with the given 'value'. More...
TiXmlNode * | NextSibling (const char *_next)
const TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | NextSiblingElement (const char *_next)
bool | NoChildren () const
| Returns true if this node has no children. More...
TiXmlNode * | Parent ()
| One step up the DOM. More...
const TiXmlNode * | Parent () const
const TiXmlNode * | PreviousSibling () const
| Navigate to a sibling node. More...
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling (const char *) const
| Navigate to a sibling node. More...
TiXmlNode * | PreviousSibling (const char *_prev)
bool | RemoveChild (TiXmlNode *removeThis)
| Delete a child of this node. More...
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
void | SetValue (const char *_value)
virtual const TiXmlComment * | ToComment () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlComment * | ToComment ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlDeclaration * | ToDeclaration () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlDeclaration * | ToDeclaration ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlElement * | ToElement () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlElement * | ToElement ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlText * | ToText () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlText * | ToText ()
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual const TiXmlUnknown * | ToUnknown () const
| Cast to a more defined type. Will return null if not of the requested type. More...
virtual TiXmlUnknown * | ToUnknown ()
| Cast to a more defined type. Will return null if not of the requested type. More...
int | Type () const
const char * | Value () const
const TIXML_STRING & | ValueTStr () const
Public Member Functions inherited from TiXmlBase
| TiXmlBase ()
virtual | ~TiXmlBase ()
int | Column () const
| See Row() More...
void * | GetUserData ()
| Get a pointer to arbitrary user data. More...
const void * | GetUserData () const
| Get a pointer to arbitrary user data. More...
int | Row () const
void | SetUserData (void *user)
| Set a pointer to arbitrary user data. More...

## Protected Member Functions

virtual TiXmlNode * | Clone () const
Protected Member Functions inherited from TiXmlNode
| TiXmlNode (NodeType _type)
void | CopyTo (TiXmlNode *target) const
TiXmlNode * | Identify (const char *start, TiXmlEncoding encoding)

## Additional Inherited Members

Public Types inherited from TiXmlNode
enum | NodeType { TINYXML_DOCUMENT, TINYXML_ELEMENT, TINYXML_COMMENT, TINYXML_UNKNOWN, TINYXML_TEXT, TINYXML_DECLARATION, TINYXML_TYPECOUNT }
Public Types inherited from TiXmlBase

enum

{
TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_PARSING_ELEMENT,
TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY,
TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION,
TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA, TIXML_ERROR_DOCUMENT_TOP_ONLY,
TIXML_ERROR_STRING_COUNT
}

Static Public Member Functions inherited from TiXmlBase
static void | EncodeString (const TIXML_STRING &str, TIXML_STRING *out)
static bool | IsWhiteSpaceCondensed ()
| Return the current white space setting. More...
static void | SetCondenseWhiteSpace (bool condense)
Static Public Attributes inherited from TiXmlBase
static const int | utf8ByteTable [256]
Static Protected Member Functions inherited from TiXmlBase
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static bool | IsWhiteSpace (char c)
static bool | IsWhiteSpace (int c)
static const char * | ReadName (const char *p, TIXML_STRING *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, TIXML_STRING *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | SkipWhiteSpace (const char *, TiXmlEncoding encoding)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
Protected Attributes inherited from TiXmlNode
TiXmlNode * | firstChild
TiXmlNode * | lastChild
TiXmlNode * | next
TiXmlNode * | parent
TiXmlNode * | prev
NodeType | type
TIXML_STRING | value
Protected Attributes inherited from TiXmlBase
TiXmlCursor | location
void * | userData
| Field containing a generic user pointer. More...
Static Protected Attributes inherited from TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

Always the top level node. A document binds together all the XML pieces. It can be saved, loaded, and printed to the screen. The 'value' of a document node is the xml file name.

Definition at line 1386 of file tinyxml.h.

## Constructor & Destructor Documentation

TiXmlDocument::TiXmlDocument | ( |  | ) |

Create an empty document, that has no name.

Definition at line 869 of file tinyxml.cpp.

References ClearError().

Referenced by Clone().

TiXmlDocument::TiXmlDocument | ( | const char * | documentName | ) |

Create a document with a name. The name of the document is also the filename of the xml.

Definition at line 876 of file tinyxml.cpp.

References ClearError().

TiXmlDocument::TiXmlDocument | ( | const TiXmlDocument & | copy | ) |

Definition at line 896 of file tinyxml.cpp.

virtual TiXmlDocument::~TiXmlDocument | ( |  | ) |

inlinevirtual

Definition at line 1402 of file tinyxml.h.

## Member Function Documentation

bool TiXmlDocument::Accept | ( | TiXmlVisitor * | content | ) | const

virtual

Walk the XML tree visiting this node and all of its children.

Implements TiXmlNode.

Definition at line 1111 of file tinyxml.cpp.

References TiXmlNode::Accept(), TiXmlNode::FirstChild(), TiXmlNode::NextSibling(), TiXmlVisitor::VisitEnter(), and TiXmlVisitor::VisitExit().

void TiXmlDocument::ClearError | ( |  | ) |

inline

If you have handled the error, it can be reset with this call. The error state is automatically cleared if you Parse a new XML block.

Definition at line 1504 of file tinyxml.h.

References error.

Referenced by Parse(), and TiXmlDocument().

TiXmlNode * TiXmlDocument::Clone | ( |  | ) | const

protectedvirtual

Create an exact duplicate of this node and return it. The memory must be deleted by the caller.

Implements TiXmlNode.

Definition at line 1089 of file tinyxml.cpp.

References TiXmlDocument().

bool TiXmlDocument::Error | ( |  | ) | const

inline

If an error occurs, Error will be set to true. Also,

- The ErrorId() will contain the integer identifier of the error (not generally useful)
- The ErrorDesc() method will return the name of the error. (very useful)
- The ErrorRow() and ErrorCol() will return the location of the error (if known)

Definition at line 1453 of file tinyxml.h.

References error.

Referenced by LoadFile().

int TiXmlDocument::ErrorCol | ( |  | ) | const

inline

The column where the error occured. See ErrorRow()

Definition at line 1471 of file tinyxml.h.

const char* TiXmlDocument::ErrorDesc | ( |  | ) | const

inline

Contains a textual (english) description of the error if one occurs.

Definition at line 1456 of file tinyxml.h.

Referenced by Zeni::XML_Document::load(), Zeni::XML_Document::load_mem(), and Zeni::XML_Document::save().

int TiXmlDocument::ErrorId | ( |  | ) | const

inline

Generally, you probably want the error string ( ErrorDesc() ). But if you prefer the ErrorId, this function will fetch it.

Definition at line 1461 of file tinyxml.h.

int TiXmlDocument::ErrorRow | ( |  | ) | const

inline

Returns the location (if known) of the error. The first column is column 1, and the first row is row 1. A value of 0 means the row and column wasn't applicable (memory errors, for example, have no row/column) or the parser lost the error. (An error in the error reporting, in that case.)

See Also
  SetTabSize, Row, Column

Definition at line 1470 of file tinyxml.h.

bool TiXmlDocument::LoadFile | ( | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING` | ) |

Load a file using the current document value. Returns true if successful. Will delete any existing document data before loading.

Definition at line 909 of file tinyxml.cpp.

References TiXmlNode::Value().

Referenced by LoadFile(), and Zeni::XML_Document::try_load().

bool TiXmlDocument::LoadFile | ( | const char * | filename,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |

Load a file using the given filename. Returns true if successful.

Definition at line 920 of file tinyxml.cpp.

References file, sort_controllers::filename, LoadFile(), SetError(), TIXML_ENCODING_UNKNOWN, TiXmlBase::TIXML_ERROR_OPENING_FILE, TIXML_STRING, and TiXmlFOpen().

bool TiXmlDocument::LoadFile | ( | FILE * | file,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |

Load a file using the given FILE*. Returns true if successful. Note that this method doesn't stream - the entire object pointed at by the FILE* will be interpreted as an XML file. TinyXML doesn't stream in XML from the current file location. Streaming may be added in the future.

Definition at line 941 of file tinyxml.cpp.

References assert, TiXmlNode::Clear(), Error(), Parse(), SEEK_END, SEEK_SET, SetError(), TIXML_ENCODING_UNKNOWN, TiXmlBase::TIXML_ERROR_DOCUMENT_EMPTY, and TiXmlBase::TIXML_ERROR_OPENING_FILE.

void TiXmlDocument::operator= | ( | const TiXmlDocument & | copy | ) |

Definition at line 902 of file tinyxml.cpp.

References TiXmlNode::Clear().

const char * TiXmlDocument::Parse | ( | const char * | p,
|  | TiXmlParsingData * | data = `0`,
|  | TiXmlEncoding | encoding = `TIXML_DEFAULT_ENCODING`
| ) |  |

virtual

Parse the given null terminated block of xml data. Passing in an encoding to this method (either TIXML_ENCODING_LEGACY or TIXML_ENCODING_UTF8 will force TinyXml to use that encoding, regardless of what TinyXml might otherwise try to detect.

Implements TiXmlBase.

Definition at line 704 of file tinyxmlparser.cpp.

References assert, ClearError(), TiXmlDeclaration::Encoding(), TiXmlNode::firstChild, TiXmlNode::Identify(), TiXmlNode::LinkEndChild(), TiXmlBase::Parse(), SetError(), TiXmlBase::SkipWhiteSpace(), TiXmlBase::StringEqual(), TabSize(), TIXML_ENCODING_LEGACY, TIXML_ENCODING_UNKNOWN, TIXML_ENCODING_UTF8, TiXmlBase::TIXML_ERROR_DOCUMENT_EMPTY, TIXML_UTF_LEAD_0, TIXML_UTF_LEAD_1, TIXML_UTF_LEAD_2, and TiXmlNode::ToDeclaration().

Referenced by LoadFile(), and Zeni::XML_Document::try_load_mem().

void TiXmlDocument::Print | ( |  | ) | const

inline

Write the document to standard out using formatted printing ("pretty print").

Definition at line 1512 of file tinyxml.h.

References Print().

Referenced by Print(), and SaveFile().

void TiXmlDocument::Print | ( | FILE * | cfile,
|  | int | depth = `0`
| ) |  | const

virtual

Print this Document to a FILE stream.

Implements TiXmlBase.

Definition at line 1100 of file tinyxml.cpp.

References assert, TiXmlNode::FirstChild(), TiXmlNode::NextSibling(), and TiXmlBase::Print().

const TiXmlElement* TiXmlDocument::RootElement | ( |  | ) | const

inline

Get the root element – the only top level element – of the document. In well formed XML, there should only be one. TinyXml is tolerant of multiple elements at the document level.

Definition at line 1445 of file tinyxml.h.

References TiXmlNode::FirstChildElement().

TiXmlElement* TiXmlDocument::RootElement | ( |  | ) |

inline

Definition at line 1446 of file tinyxml.h.

References TiXmlNode::FirstChildElement().

bool TiXmlDocument::SaveFile | ( |  | ) | const

Save a file using the current document value. Returns true if successful.

Definition at line 915 of file tinyxml.cpp.

References TiXmlNode::Value().

Referenced by SaveFile(), and Zeni::XML_Document::try_save().

bool TiXmlDocument::SaveFile | ( | const char * | filename | ) | const

Save a file using the given filename. Returns true if successful.

Definition at line 1039 of file tinyxml.cpp.

References SaveFile(), and TiXmlFOpen().

bool TiXmlDocument::SaveFile | ( | FILE * | fp | ) | const

Save a file using the given FILE*. Returns true if successful.

Definition at line 1053 of file tinyxml.cpp.

References Print(), TIXML_UTF_LEAD_0, TIXML_UTF_LEAD_1, and TIXML_UTF_LEAD_2.

void TiXmlDocument::SetError | ( | int | err,
|  | const char * | errorLocation,
|  | TiXmlParsingData * | prevData,
|  | TiXmlEncoding | encoding
| ) |  |

Definition at line 798 of file tinyxmlparser.cpp.

References assert, TiXmlCursor::Clear(), TiXmlBase::errorString, and TiXmlBase::TIXML_ERROR_STRING_COUNT.

Referenced by TiXmlNode::InsertAfterChild(), TiXmlNode::InsertBeforeChild(), TiXmlNode::InsertEndChild(), TiXmlNode::LinkEndChild(), LoadFile(), TiXmlAttribute::Parse(), TiXmlElement::Parse(), TiXmlComment::Parse(), TiXmlText::Parse(), TiXmlDeclaration::Parse(), TiXmlUnknown::Parse(), Parse(), TiXmlElement::ReadValue(), and TiXmlNode::ReplaceChild().

void TiXmlDocument::SetTabSize | ( | int | _tabsize | ) |

inline

SetTabSize() allows the error reporting functions (ErrorRow() and ErrorCol()) to report the correct values for row and column. It does not change the output or input in any way.

By calling this method, with a tab size greater than 0, the row and column of each node and attribute is stored when the file is loaded. Very useful for tracking the DOM back in to the source file.

The tab size is required for calculating the location of nodes. If not set, the default of 4 is used. The tabsize is set per document. Setting the tabsize to 0 disables row/column tracking.

Note that row and column tracking is not supported when using operator>>.

The tab size needs to be enabled before the parse or load. Correct usage:

    TiXmlDocument doc;
    doc.SetTabSize( 8 );
    doc.Load( "myfile.xml" );

See Also
  Row, Column

Definition at line 1497 of file tinyxml.h.

int TiXmlDocument::TabSize | ( |  | ) | const

inline

Definition at line 1499 of file tinyxml.h.

Referenced by Parse().

virtual const TiXmlDocument* TiXmlDocument::ToDocument | ( |  | ) | const

inlinevirtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

Definition at line 1525 of file tinyxml.h.

virtual TiXmlDocument* TiXmlDocument::ToDocument | ( |  | ) |

inlinevirtual

Cast to a more defined type. Will return null not of the requested type.

Reimplemented from TiXmlNode.

Definition at line 1526 of file tinyxml.h.

The documentation for this class was generated from the following files:

- zenilib/jni/external/tinyxml/tinyxml.h
- zenilib/jni/external/tinyxml/tinyxml.cpp
- zenilib/jni/external/tinyxml/tinyxmlparser.cpp